-
Data Grid
- Overview
-
Data Binding
-
Paging and Scrolling
-
Editing
-
Grouping
-
Filtering and Sorting
- Focused Row
-
Row Drag & Drop
-
Selection
-
Columns
- State Persistence
-
Appearance
-
Templates
-
Data Summaries
-
Master-Detail
-
Export to PDF
-
Export to Excel
-
Adaptability
- Keyboard Navigation
-
Pivot Grid
- Overview
-
Data Binding
-
Field Chooser
-
Features
-
Export to Excel
-
Tree List
- Overview
-
Data Binding
- Sorting
- Paging
-
Editing
- Node Drag & Drop
- Focused Row
-
Selection
-
Filtering
-
Column Customization
- State Persistence
- Adaptability
- Keyboard Navigation
-
Card View
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Features
- Virtual Scrolling
-
Grouping
-
Customization
- Adaptability
-
Html Editor
-
Chat
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
Charts
- Overview
-
Data Binding
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Line Charts
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
-
Sparkline Charts
-
Tree Map
-
Funnel and Pyramid Charts
- Sankey Chart
-
Combinations
-
More Features
-
Export
-
Selection
-
Tooltips
-
Zooming
-
-
Gantt
- Overview
-
Data
-
UI Customization
- Strip Lines
- Export to PDF
- Sorting
-
Filtering
-
Gauges
- Overview
-
Data Binding
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Navigation
- Overview
- Accordion
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
- Stepper
- Pagination
-
Tree View
- Right-to-Left Support
-
Layout
-
Editors
- Overview
- Autocomplete
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Drop Down Box
-
Number Box
-
Select Box
- Switch
-
Tag Box
- Text Area
- Text Box
- Validation
- Custom Text Editor Buttons
- Right-to-Left Support
- Editor Appearance Variants
-
Forms and Multi-Purpose
- Overview
- Button Group
- Field Set
-
Filter Builder
-
Form
- Radio Group
-
Range Selector
- Numeric Scale (Lightweight)
- Numeric Scale
- Date-Time Scale (Lightweight)
- Date-Time Scale
- Logarithmic Scale
- Discrete scale
- Custom Formatting
- Use Range Selection for Calculation
- Use Range Selection for Filtering
- Image on Background
- Chart on Background
- Customized Chart on Background
- Chart on Background with Series Template
- Range Slider
- Slider
-
Sortable
-
File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Actions and Lists
- Overview
-
Action Sheet
-
Button
- Floating Action Button
- Drop Down Button
-
Context Menu
-
List
-
Lookup
-
Maps
- Overview
-
Map
-
Vector Map
-
Dialogs and Notifications
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Grid - Multi-Level Headers (Bands)
Our JavaScript DataGrid component allows you to group multiple columns under one header (band). This demo shows an example: the "Nominal GDP" and "Population" bands have banded columns.
You can drag one of the bands across the grid to reorder all its banded columns simultaneously. You can also move the band to the column chooser and hide the banded columns. Banded columns remain interactive.
www.wikipedia.org
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
$('#gridContainer').dxDataGrid({
dataSource: countries,
keyExpr: 'ID',
columnAutoWidth: true,
allowColumnReordering: true,
width: '100%',
showBorders: true,
columnChooser: {
enabled: true,
},
columns: ['Country', {
headerCellTemplate(container) {
container.append($('<div>Area, km<sup>2</sup></div>'));
},
dataField: 'Area',
}, {
caption: 'Population',
columns: [{
caption: 'Total',
dataField: 'Population_Total',
format: 'fixedPoint',
}, {
caption: 'Urban',
dataField: 'Population_Urban',
format: 'percent',
}],
}, {
caption: 'Nominal GDP',
columns: [{
caption: 'Total, mln $',
dataField: 'GDP_Total',
format: 'fixedPoint',
sortOrder: 'desc',
}, {
caption: 'By Sector',
columns: [{
caption: 'Agriculture',
dataField: 'GDP_Agriculture',
width: 95,
format: {
type: 'percent',
precision: 1,
},
}, {
caption: 'Industry',
dataField: 'GDP_Industry',
width: 80,
format: {
type: 'percent',
precision: 1,
},
}, {
caption: 'Services',
dataField: 'GDP_Services',
width: 85,
format: {
type: 'percent',
precision: 1,
},
}],
}],
}],
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Country Area, Population, and GDP Structure</h3></div>
<div id="gridContainer"></div>
</div>
</body>
</html>
#gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.long-title {
position: absolute;
top: -5px;
left: 0;
right: 45px;
z-index: 1;
}
.long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin: 0 0 0 45px;
}
const countries = [{
ID: 1,
Country: 'Brazil',
Area: 8515767,
Population_Urban: 0.85,
Population_Rural: 0.15,
Population_Total: 205809000,
GDP_Agriculture: 0.054,
GDP_Industry: 0.274,
GDP_Services: 0.672,
GDP_Total: 2353025,
}, {
ID: 2,
Country: 'China',
Area: 9388211,
Population_Urban: 0.54,
Population_Rural: 0.46,
Population_Total: 1375530000,
GDP_Agriculture: 0.091,
GDP_Industry: 0.426,
GDP_Services: 0.483,
GDP_Total: 10380380,
}, {
ID: 3,
Country: 'France',
Area: 675417,
Population_Urban: 0.79,
Population_Rural: 0.21,
Population_Total: 64529000,
GDP_Agriculture: 0.019,
GDP_Industry: 0.183,
GDP_Services: 0.798,
GDP_Total: 2846889,
}, {
ID: 4,
Country: 'Germany',
Area: 357021,
Population_Urban: 0.75,
Population_Rural: 0.25,
Population_Total: 81459000,
GDP_Agriculture: 0.008,
GDP_Industry: 0.281,
GDP_Services: 0.711,
GDP_Total: 3859547,
}, {
ID: 5,
Country: 'India',
Area: 3287590,
Population_Urban: 0.32,
Population_Rural: 0.68,
Population_Total: 1286260000,
GDP_Agriculture: 0.174,
GDP_Industry: 0.258,
GDP_Services: 0.569,
GDP_Total: 2047811,
}, {
ID: 6,
Country: 'Italy',
Area: 301230,
Population_Urban: 0.69,
Population_Rural: 0.31,
Population_Total: 60676361,
GDP_Agriculture: 0.02,
GDP_Industry: 0.242,
GDP_Services: 0.738,
GDP_Total: 2147952,
}, {
ID: 7,
Country: 'Japan',
Area: 377835,
Population_Urban: 0.93,
Population_Rural: 0.07,
Population_Total: 126920000,
GDP_Agriculture: 0.012,
GDP_Industry: 0.275,
GDP_Services: 0.714,
GDP_Total: 4616335,
}, {
ID: 8,
Country: 'Russia',
Area: 17098242,
Population_Urban: 0.74,
Population_Rural: 0.26,
Population_Total: 146544710,
GDP_Agriculture: 0.039,
GDP_Industry: 0.36,
GDP_Services: 0.601,
GDP_Total: 1857461,
}, {
ID: 9,
Country: 'United States',
Area: 9147420,
Population_Urban: 0.81,
Population_Rural: 0.19,
Population_Total: 323097000,
GDP_Agriculture: 0.0112,
GDP_Industry: 0.191,
GDP_Services: 0.797,
GDP_Total: 17418925,
}, {
ID: 10,
Country: 'United Kingdom',
Area: 244820,
Population_Urban: 0.82,
Population_Rural: 0.18,
Population_Total: 65097000,
GDP_Agriculture: 0.007,
GDP_Industry: 0.21,
GDP_Services: 0.783,
GDP_Total: 2945146,
}];
To create the banded layout, do one of the following:
-
Assign a hierarchical structure to the columns property. The code in this demo is an example.
-
Implement a customizeColumns function where you should specify the ownerBand and isBand column properties. Refer to the isBand description for a code sample.

Backend API
import React from 'react';
import DataGrid, { Column, ColumnChooser } from 'devextreme-react/data-grid';
import { countries } from './data.ts';
const gdpFormat = {
type: 'percent',
precision: 1,
};
const renderAreaCellHeader = () => <div>Area, km<sup>2</sup></div>;
const App = () => (
<>
<div id="long-title">
<h3>Country Area, Population, and GDP Structure</h3>
</div>
<DataGrid
id="grid"
dataSource={countries}
keyExpr="ID"
columnAutoWidth={true}
allowColumnReordering={true}
width="100%"
showBorders={true}
>
<ColumnChooser enabled={true} />
<Column dataField="Country" />
<Column dataField="Area" headerCellRender={renderAreaCellHeader} />
<Column caption="Population">
<Column
dataField="Population_Total"
caption="Total"
format="fixedPoint"
/>
<Column
dataField="Population_Urban"
caption="Urban"
format="percent"
/>
</Column>
<Column caption="Nominal GDP">
<Column
dataField="GDP_Total"
caption="Total, mln $"
format="fixedPoint"
sortOrder="desc"
/>
<Column caption="By Sector">
<Column
dataField="GDP_Agriculture"
caption="Agriculture"
format={gdpFormat}
width={95}
/>
<Column
dataField="GDP_Industry"
caption="Industry"
format={gdpFormat}
width={80}
/>
<Column
dataField="GDP_Services"
caption="Services"
format={gdpFormat}
width={85}
/>
</Column>
</Column>
</DataGrid>
</>
);
export default App;
import React from 'react';
import DataGrid, { Column, ColumnChooser } from 'devextreme-react/data-grid';
import { countries } from './data.js';
const gdpFormat = {
type: 'percent',
precision: 1,
};
const renderAreaCellHeader = () => (
<div>
Area, km<sup>2</sup>
</div>
);
const App = () => (
<>
<div id="long-title">
<h3>Country Area, Population, and GDP Structure</h3>
</div>
<DataGrid
id="grid"
dataSource={countries}
keyExpr="ID"
columnAutoWidth={true}
allowColumnReordering={true}
width="100%"
showBorders={true}
>
<ColumnChooser enabled={true} />
<Column dataField="Country" />
<Column
dataField="Area"
headerCellRender={renderAreaCellHeader}
/>
<Column caption="Population">
<Column
dataField="Population_Total"
caption="Total"
format="fixedPoint"
/>
<Column
dataField="Population_Urban"
caption="Urban"
format="percent"
/>
</Column>
<Column caption="Nominal GDP">
<Column
dataField="GDP_Total"
caption="Total, mln $"
format="fixedPoint"
sortOrder="desc"
/>
<Column caption="By Sector">
<Column
dataField="GDP_Agriculture"
caption="Agriculture"
format={gdpFormat}
width={95}
/>
<Column
dataField="GDP_Industry"
caption="Industry"
format={gdpFormat}
width={80}
/>
<Column
dataField="GDP_Services"
caption="Services"
format={gdpFormat}
width={85}
/>
</Column>
</Column>
</DataGrid>
</>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const countries = [{
ID: 1,
Country: 'Brazil',
Area: 8515767,
Population_Urban: 0.85,
Population_Rural: 0.15,
Population_Total: 205809000,
GDP_Agriculture: 0.054,
GDP_Industry: 0.274,
GDP_Services: 0.672,
GDP_Total: 2353025,
}, {
ID: 2,
Country: 'China',
Area: 9388211,
Population_Urban: 0.54,
Population_Rural: 0.46,
Population_Total: 1375530000,
GDP_Agriculture: 0.091,
GDP_Industry: 0.426,
GDP_Services: 0.483,
GDP_Total: 10380380,
}, {
ID: 3,
Country: 'France',
Area: 675417,
Population_Urban: 0.79,
Population_Rural: 0.21,
Population_Total: 64529000,
GDP_Agriculture: 0.019,
GDP_Industry: 0.183,
GDP_Services: 0.798,
GDP_Total: 2846889,
}, {
ID: 4,
Country: 'Germany',
Area: 357021,
Population_Urban: 0.75,
Population_Rural: 0.25,
Population_Total: 81459000,
GDP_Agriculture: 0.008,
GDP_Industry: 0.281,
GDP_Services: 0.711,
GDP_Total: 3859547,
}, {
ID: 5,
Country: 'India',
Area: 3287590,
Population_Urban: 0.32,
Population_Rural: 0.68,
Population_Total: 1286260000,
GDP_Agriculture: 0.174,
GDP_Industry: 0.258,
GDP_Services: 0.569,
GDP_Total: 2047811,
}, {
ID: 6,
Country: 'Italy',
Area: 301230,
Population_Urban: 0.69,
Population_Rural: 0.31,
Population_Total: 60676361,
GDP_Agriculture: 0.02,
GDP_Industry: 0.242,
GDP_Services: 0.738,
GDP_Total: 2147952,
}, {
ID: 7,
Country: 'Japan',
Area: 377835,
Population_Urban: 0.93,
Population_Rural: 0.07,
Population_Total: 126920000,
GDP_Agriculture: 0.012,
GDP_Industry: 0.275,
GDP_Services: 0.714,
GDP_Total: 4616335,
}, {
ID: 8,
Country: 'Russia',
Area: 17098242,
Population_Urban: 0.74,
Population_Rural: 0.26,
Population_Total: 146544710,
GDP_Agriculture: 0.039,
GDP_Industry: 0.36,
GDP_Services: 0.601,
GDP_Total: 1857461,
}, {
ID: 9,
Country: 'United States',
Area: 9147420,
Population_Urban: 0.81,
Population_Rural: 0.19,
Population_Total: 323097000,
GDP_Agriculture: 0.0112,
GDP_Industry: 0.191,
GDP_Services: 0.797,
GDP_Total: 17418925,
}, {
ID: 10,
Country: 'United Kingdom',
Area: 244820,
Population_Urban: 0.82,
Population_Rural: 0.18,
Population_Total: 65097000,
GDP_Agriculture: 0.007,
GDP_Industry: 0.21,
GDP_Services: 0.783,
GDP_Total: 2945146,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const countries = [
{
ID: 1,
Country: 'Brazil',
Area: 8515767,
Population_Urban: 0.85,
Population_Rural: 0.15,
Population_Total: 205809000,
GDP_Agriculture: 0.054,
GDP_Industry: 0.274,
GDP_Services: 0.672,
GDP_Total: 2353025,
},
{
ID: 2,
Country: 'China',
Area: 9388211,
Population_Urban: 0.54,
Population_Rural: 0.46,
Population_Total: 1375530000,
GDP_Agriculture: 0.091,
GDP_Industry: 0.426,
GDP_Services: 0.483,
GDP_Total: 10380380,
},
{
ID: 3,
Country: 'France',
Area: 675417,
Population_Urban: 0.79,
Population_Rural: 0.21,
Population_Total: 64529000,
GDP_Agriculture: 0.019,
GDP_Industry: 0.183,
GDP_Services: 0.798,
GDP_Total: 2846889,
},
{
ID: 4,
Country: 'Germany',
Area: 357021,
Population_Urban: 0.75,
Population_Rural: 0.25,
Population_Total: 81459000,
GDP_Agriculture: 0.008,
GDP_Industry: 0.281,
GDP_Services: 0.711,
GDP_Total: 3859547,
},
{
ID: 5,
Country: 'India',
Area: 3287590,
Population_Urban: 0.32,
Population_Rural: 0.68,
Population_Total: 1286260000,
GDP_Agriculture: 0.174,
GDP_Industry: 0.258,
GDP_Services: 0.569,
GDP_Total: 2047811,
},
{
ID: 6,
Country: 'Italy',
Area: 301230,
Population_Urban: 0.69,
Population_Rural: 0.31,
Population_Total: 60676361,
GDP_Agriculture: 0.02,
GDP_Industry: 0.242,
GDP_Services: 0.738,
GDP_Total: 2147952,
},
{
ID: 7,
Country: 'Japan',
Area: 377835,
Population_Urban: 0.93,
Population_Rural: 0.07,
Population_Total: 126920000,
GDP_Agriculture: 0.012,
GDP_Industry: 0.275,
GDP_Services: 0.714,
GDP_Total: 4616335,
},
{
ID: 8,
Country: 'Russia',
Area: 17098242,
Population_Urban: 0.74,
Population_Rural: 0.26,
Population_Total: 146544710,
GDP_Agriculture: 0.039,
GDP_Industry: 0.36,
GDP_Services: 0.601,
GDP_Total: 1857461,
},
{
ID: 9,
Country: 'United States',
Area: 9147420,
Population_Urban: 0.81,
Population_Rural: 0.19,
Population_Total: 323097000,
GDP_Agriculture: 0.0112,
GDP_Industry: 0.191,
GDP_Services: 0.797,
GDP_Total: 17418925,
},
{
ID: 10,
Country: 'United Kingdom',
Area: 244820,
Population_Urban: 0.82,
Population_Rural: 0.18,
Population_Total: 65097000,
GDP_Agriculture: 0.007,
GDP_Industry: 0.21,
GDP_Services: 0.783,
GDP_Total: 2945146,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
#long-title {
position: absolute;
top: -5px;
left: 0;
right: 45px;
z-index: 1;
}
#long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin: 0 0 0 45px;
}
To create the banded layout, do one of the following:
-
Assign a hierarchical structure to the columns property. The code in this demo is an example.
-
Implement a customizeColumns function where you should specify the ownerBand and isBand column properties. Refer to the isBand description for a code sample.

Backend API
<template>
<div id="long-title">
<h3>Country Area, Population, and GDP Structure</h3>
</div>
<DxDataGrid
id="grid"
:data-source="countries"
:key-expr="'ID'"
:column-auto-width="true"
:allow-column-reordering="true"
:width="'100%'"
:show-borders="true"
>
<DxColumnChooser :enabled="true"/>
<DxColumn data-field="Country"/>
<DxColumn
data-field="Area"
header-cell-template="headerTemplate"
/>
<DxColumn caption="Population">
<DxColumn
caption="Total"
data-field="Population_Total"
format="fixedPoint"
/>
<DxColumn
caption="Urban"
data-field="Population_Urban"
format="percent"
/>
</DxColumn>
<DxColumn caption="Nominal GDP">
<DxColumn
caption="Total, mln $"
data-field="GDP_Total"
format="fixedPoint"
sort-order="desc"
/>
<DxColumn caption="By Sector">
<DxColumn
:width="95"
:format="gdpFormat"
caption="Agriculture"
data-field="GDP_Agriculture"
/>
<DxColumn
:width="80"
:format="gdpFormat"
caption="Industry"
data-field="GDP_Industry"
/>
<DxColumn
:width="85"
:format="gdpFormat"
caption="Services"
data-field="GDP_Services"
/>
</DxColumn>
</DxColumn>
<template #headerTemplate>
<div>Area, km<sup>2</sup></div>
</template>
</DxDataGrid>
</template>
<script setup lang="ts">
import DxDataGrid, { DxColumn, DxColumnChooser } from 'devextreme-vue/data-grid';
import { countries } from './data.ts';
const gdpFormat = {
type: 'percent',
precision: 1,
};
</script>
<style>
#grid sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
#long-title {
position: absolute;
top: -5px;
left: 0;
right: 45px;
z-index: 1;
}
#long-title h3 {
font-family:
'Segoe UI Light',
'Helvetica Neue Light',
'Segoe UI',
'Helvetica Neue',
'Trebuchet MS',
Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin: 0 0 0 45px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type Country = {
ID: number;
Country: string;
Area: number;
Population_Urban: number;
Population_Rural: number;
Population_Total: number;
GDP_Agriculture: number;
GDP_Industry: number;
GDP_Services: number;
GDP_Total: number;
};
export const countries: Country[] = [{
ID: 1,
Country: 'Brazil',
Area: 8515767,
Population_Urban: 0.85,
Population_Rural: 0.15,
Population_Total: 205809000,
GDP_Agriculture: 0.054,
GDP_Industry: 0.274,
GDP_Services: 0.672,
GDP_Total: 2353025,
}, {
ID: 2,
Country: 'China',
Area: 9388211,
Population_Urban: 0.54,
Population_Rural: 0.46,
Population_Total: 1375530000,
GDP_Agriculture: 0.091,
GDP_Industry: 0.426,
GDP_Services: 0.483,
GDP_Total: 10380380,
}, {
ID: 3,
Country: 'France',
Area: 675417,
Population_Urban: 0.79,
Population_Rural: 0.21,
Population_Total: 64529000,
GDP_Agriculture: 0.019,
GDP_Industry: 0.183,
GDP_Services: 0.798,
GDP_Total: 2846889,
}, {
ID: 4,
Country: 'Germany',
Area: 357021,
Population_Urban: 0.75,
Population_Rural: 0.25,
Population_Total: 81459000,
GDP_Agriculture: 0.008,
GDP_Industry: 0.281,
GDP_Services: 0.711,
GDP_Total: 3859547,
}, {
ID: 5,
Country: 'India',
Area: 3287590,
Population_Urban: 0.32,
Population_Rural: 0.68,
Population_Total: 1286260000,
GDP_Agriculture: 0.174,
GDP_Industry: 0.258,
GDP_Services: 0.569,
GDP_Total: 2047811,
}, {
ID: 6,
Country: 'Italy',
Area: 301230,
Population_Urban: 0.69,
Population_Rural: 0.31,
Population_Total: 60676361,
GDP_Agriculture: 0.02,
GDP_Industry: 0.242,
GDP_Services: 0.738,
GDP_Total: 2147952,
}, {
ID: 7,
Country: 'Japan',
Area: 377835,
Population_Urban: 0.93,
Population_Rural: 0.07,
Population_Total: 126920000,
GDP_Agriculture: 0.012,
GDP_Industry: 0.275,
GDP_Services: 0.714,
GDP_Total: 4616335,
}, {
ID: 8,
Country: 'Russia',
Area: 17098242,
Population_Urban: 0.74,
Population_Rural: 0.26,
Population_Total: 146544710,
GDP_Agriculture: 0.039,
GDP_Industry: 0.36,
GDP_Services: 0.601,
GDP_Total: 1857461,
}, {
ID: 9,
Country: 'United States',
Area: 9147420,
Population_Urban: 0.81,
Population_Rural: 0.19,
Population_Total: 323097000,
GDP_Agriculture: 0.0112,
GDP_Industry: 0.191,
GDP_Services: 0.797,
GDP_Total: 17418925,
}, {
ID: 10,
Country: 'United Kingdom',
Area: 244820,
Population_Urban: 0.82,
Population_Rural: 0.18,
Population_Total: 65097000,
GDP_Agriculture: 0.007,
GDP_Industry: 0.21,
GDP_Services: 0.783,
GDP_Total: 2945146,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
To create the banded layout, do one of the following:
-
Assign a hierarchical structure to the columns property. The code in this demo is an example.
-
Implement a customizeColumns function where you should specify the ownerBand and isBand column properties. Refer to the isBand description for a code sample.

Backend API
<div id="long-title">
<h3>Country Area, Population, and GDP Structure</h3>
</div>
<dx-data-grid
id="gridContainer"
[dataSource]="countries"
[keyExpr]="'ID'"
[columnAutoWidth]="true"
[width]="'100%'"
[showBorders]="true"
[allowColumnReordering]="true"
>
<dxo-column-chooser [enabled]="true"></dxo-column-chooser>
<dxi-column dataField="Country"> </dxi-column>
<dxi-column dataField="Area" headerCellTemplate="headerTemplate">
</dxi-column>
<dxi-column caption="Population">
<dxi-column
caption="Total"
dataField="Population_Total"
format="fixedPoint"
>
</dxi-column>
<dxi-column caption="Urban" dataField="Population_Urban" format="percent">
</dxi-column>
</dxi-column>
<dxi-column caption="Nominal GDP">
<dxi-column
caption="Total, mln $"
dataField="GDP_Total"
format="fixedPoint"
sortOrder="desc"
>
</dxi-column>
<dxi-column caption="By Sector">
<dxi-column
caption="Agriculture"
[width]="95"
dataField="GDP_Agriculture"
>
<dxo-format type="percent" [precision]="1"> </dxo-format>
</dxi-column>
<dxi-column caption="Industry" [width]="80" dataField="GDP_Industry">
<dxo-format type="percent" [precision]="1"> </dxo-format>
</dxi-column>
<dxi-column caption="Services" [width]="85" dataField="GDP_Services">
<dxo-format type="percent" [precision]="1"> </dxo-format>
</dxi-column>
</dxi-column>
</dxi-column>
<div *dxTemplate="let data of 'headerTemplate'">
<div>Area, km<sup>2</sup></div>
</div>
</dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule, DxTemplateModule } from 'devextreme-angular';
import { Service, Country } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
})
export class AppComponent {
countries: Country[];
constructor(service: Service) {
this.countries = service.getCountries();
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxTemplateModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
::ng-deep #long-title {
position: absolute;
top: -5px;
left: 0;
right: 45px;
z-index: 1;
}
::ng-deep #long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin: 0 0 0 45px;
}
import { Injectable } from '@angular/core';
export class Country {
ID: number;
Country: string;
Area: number;
Population_Urban: number;
Population_Rural: number;
Population_Total: number;
GDP_Agriculture: number;
GDP_Industry: number;
GDP_Services: number;
GDP_Total: number;
}
const countries: Country[] = [{
ID: 1,
Country: 'Brazil',
Area: 8515767,
Population_Urban: 0.85,
Population_Rural: 0.15,
Population_Total: 205809000,
GDP_Agriculture: 0.054,
GDP_Industry: 0.274,
GDP_Services: 0.672,
GDP_Total: 2353025,
}, {
ID: 2,
Country: 'China',
Area: 9388211,
Population_Urban: 0.54,
Population_Rural: 0.46,
Population_Total: 1375530000,
GDP_Agriculture: 0.091,
GDP_Industry: 0.426,
GDP_Services: 0.483,
GDP_Total: 10380380,
}, {
ID: 3,
Country: 'France',
Area: 675417,
Population_Urban: 0.79,
Population_Rural: 0.21,
Population_Total: 64529000,
GDP_Agriculture: 0.019,
GDP_Industry: 0.183,
GDP_Services: 0.798,
GDP_Total: 2846889,
}, {
ID: 4,
Country: 'Germany',
Area: 357021,
Population_Urban: 0.75,
Population_Rural: 0.25,
Population_Total: 81459000,
GDP_Agriculture: 0.008,
GDP_Industry: 0.281,
GDP_Services: 0.711,
GDP_Total: 3859547,
}, {
ID: 5,
Country: 'India',
Area: 3287590,
Population_Urban: 0.32,
Population_Rural: 0.68,
Population_Total: 1286260000,
GDP_Agriculture: 0.174,
GDP_Industry: 0.258,
GDP_Services: 0.569,
GDP_Total: 2047811,
}, {
ID: 6,
Country: 'Italy',
Area: 301230,
Population_Urban: 0.69,
Population_Rural: 0.31,
Population_Total: 60676361,
GDP_Agriculture: 0.02,
GDP_Industry: 0.242,
GDP_Services: 0.738,
GDP_Total: 2147952,
}, {
ID: 7,
Country: 'Japan',
Area: 377835,
Population_Urban: 0.93,
Population_Rural: 0.07,
Population_Total: 126920000,
GDP_Agriculture: 0.012,
GDP_Industry: 0.275,
GDP_Services: 0.714,
GDP_Total: 4616335,
}, {
ID: 8,
Country: 'Russia',
Area: 17098242,
Population_Urban: 0.74,
Population_Rural: 0.26,
Population_Total: 146544710,
GDP_Agriculture: 0.039,
GDP_Industry: 0.36,
GDP_Services: 0.601,
GDP_Total: 1857461,
}, {
ID: 9,
Country: 'United States',
Area: 9147420,
Population_Urban: 0.81,
Population_Rural: 0.19,
Population_Total: 323097000,
GDP_Agriculture: 0.0112,
GDP_Industry: 0.191,
GDP_Services: 0.797,
GDP_Total: 17418925,
}, {
ID: 10,
Country: 'United Kingdom',
Area: 244820,
Population_Urban: 0.82,
Population_Rural: 0.18,
Population_Total: 65097000,
GDP_Agriculture: 0.007,
GDP_Industry: 0.21,
GDP_Services: 0.783,
GDP_Total: 2945146,
}];
@Injectable()
export class Service {
getCountries(): Country[] {
return countries;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
To create the banded layout, do one of the following:
-
Assign a hierarchical structure to the columns property. The code in this demo is an example.
-
Implement a customizeColumns function where you should specify the ownerBand and isBand column properties. Refer to the isBand description for a code sample.